## org.apache.mahout.clustering.spectral.eigencuts
Class EigencutsDriver

    java.lang.Object
      org.apache.hadoop.conf.Configured
          org.apache.mahout.common.AbstractJob
              org.apache.mahout.clustering.spectral.eigencuts.EigencutsDriver

All Implemented Interfaces:
  org.apache.hadoop.conf.Configurable, org.apache.hadoop.util.Tool

    public class EigencutsDriver

extends AbstractJob

Field Summary
`static double` `EPSILON_DEFAULT`
`static double` `OVERSHOOT_MULTIPLIER`
`static double` `TAU_DEFAULT`

Constructor Summary
`EigencutsDriver()`

Method Summary
`static void` `main(java.lang.String[] args)`

`static DistributedRowMatrix`

`performEigenDecomposition(org.apache.hadoop.conf.Configuration conf, DistributedRowMatrix input, int numEigenVectors, int overshoot, java.util.List<java.lang.Double> eigenValues, Matrix eigenVectors, org.apache.hadoop.fs.Path tmp)`
Does most of the heavy lifting in setting up Paths, configuring return values, and generally performing the tedious administrative tasks involved in an eigen-decomposition and running the verifier

`static void` `run(org.apache.hadoop.conf.Configuration conf, org.apache.hadoop.fs.Path input, org.apache.hadoop.fs.Path output, int dimensions, double halflife, double epsilon, double tau)` Run the Eigencuts clustering algorithm using the supplied arguments
`int` `run(java.lang.String[] arg0)`

Methods inherited from class org.apache.mahout.common.AbstractJob
`addFlag, addInputOption, addOption, addOption, addOption, addOption, addOutputOption, getInputPath, getOption, getOutputPath, hasOption, keyFor, maybePut, parseArguments, parseDirectories, prepareJob, shouldRunNextPhase`

Methods inherited from class org.apache.hadoop.conf.Configured
`getConf, setConf`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.hadoop.conf.Configurable
`getConf, setConf`

Field Detail

### EPSILON_DEFAULT

    public static final double EPSILON_DEFAULT

See Also:
  Constant Field Values

### TAU_DEFAULT

    public static final double TAU_DEFAULT

See Also:
  Constant Field Values

### OVERSHOOT_MULTIPLIER

    public static final double OVERSHOOT_MULTIPLIER

See Also:
  Constant Field Values

Constructor Detail

### EigencutsDriver

    public EigencutsDriver()

Method Detail

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### run

    public int run(java.lang.String[] arg0)
            throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### run

    public static void run(org.apache.hadoop.conf.Configuration conf,
                           org.apache.hadoop.fs.Path input,
                           org.apache.hadoop.fs.Path output,
                           int dimensions,
                           double halflife,
                           double epsilon,
                           double tau)
                    throws java.io.IOException,
                           java.lang.InterruptedException,
                           java.lang.ClassNotFoundException

  Run the Eigencuts clustering algorithm using the supplied arguments

  Parameters:
    `conf` - the Configuration to use
    `input` - the Path to the directory containing input affinity tuples
    `output` - the Path to the output directory
    `dimensions` - the int number of dimensions of the square affinity matrix
    `halflife` - the double minimum half-life threshold
    `epsilon` - the double coefficient for setting minimum half-life threshold
    `tau` - the double tau threshold for cutting links in the affinity graph
  Throws:
    `java.io.IOException`
    `java.lang.InterruptedException`
    `java.lang.ClassNotFoundException`

### performEigenDecomposition

    public static DistributedRowMatrix performEigenDecomposition(org.apache.hadoop.conf.Configuration conf,
                                                                 DistributedRowMatrix input,
                                                                 int numEigenVectors,
                                                                 int overshoot,
                                                                 java.util.List<java.lang.Double> eigenValues,
                                                                 Matrix eigenVectors,
                                                                 org.apache.hadoop.fs.Path tmp)
                                                          throws java.io.IOException

  Does most of the heavy lifting in setting up Paths, configuring return values, and generally performing the tedious administrative tasks involved in an eigen-decomposition and running the verifier

  Throws:
    `java.io.IOException`

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.